### Beta 4.1

|--------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Release date**         | May 13, 2025                                                                                                                                                       |
| **Build**                | BP22.250325.012                                                                                                                                                    |
| **Emulator support**     | x86 (64-bit), ARM (v8-A)                                                                                                                                           |
| **Security patch level** | April 2025                                                                                                                                                         |
| **Google Play services** | 25.07.34                                                                                                                                                           |
| **API diff**             | - [Baklava Beta 2 → API 36](https://developer.android.com/sdk/api_diff/36-incr/changes) - [API 35 → API 36](https://developer.android.com/sdk/api_diff/36/changes) |

### Beta 4.0

|--------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Release date**         | April 17, 2025                                                                                                                                                     |
| **Build**                | BP22.250325.007                                                                                                                                                    |
| **Emulator support**     | x86 (64-bit), ARM (v8-A)                                                                                                                                           |
| **Security patch level** | April 2025                                                                                                                                                         |
| **Google Play services** | 25.07.34                                                                                                                                                           |
| **API diff**             | - [Baklava Beta 2 → API 36](https://developer.android.com/sdk/api_diff/36-incr/changes) - [API 35 → API 36](https://developer.android.com/sdk/api_diff/36/changes) |

### Beta 3.2

|--------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Release date**         | April 2, 2025                                                                                                                                                      |
| **Build**                | BP22.250221.015                                                                                                                                                    |
| **Emulator support**     | x86 (64-bit), ARM (v8-A)                                                                                                                                           |
| **Security patch level** | March 2025                                                                                                                                                         |
| **Google Play services** | 25.07.33                                                                                                                                                           |
| **API diff**             | - [Baklava Beta 2 → API 36](https://developer.android.com/sdk/api_diff/36-incr/changes) - [API 35 → API 36](https://developer.android.com/sdk/api_diff/36/changes) |

### Beta 3.1

|--------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Release date**         | March 18, 2025                                                                                                                                                     |
| **Build**                | BP22.250221.013                                                                                                                                                    |
| **Emulator support**     | x86 (64-bit), ARM (v8-A)                                                                                                                                           |
| **Security patch level** | March 2025                                                                                                                                                         |
| **Google Play services** | 25.07.33                                                                                                                                                           |
| **API diff**             | - [Baklava Beta 2 → API 36](https://developer.android.com/sdk/api_diff/36-incr/changes) - [API 35 → API 36](https://developer.android.com/sdk/api_diff/36/changes) |

### Beta 3

|--------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Release date**         | March 13, 2025                                                                                                                                                     |
| **Build**                | BP22.250221.010                                                                                                                                                    |
| **Emulator support**     | x86 (64-bit), ARM (v8-A)                                                                                                                                           |
| **Security patch level** | March 2025                                                                                                                                                         |
| **Google Play services** | 25.07.33                                                                                                                                                           |
| **API diff**             | - [Baklava Beta 2 → API 36](https://developer.android.com/sdk/api_diff/36-incr/changes) - [API 35 → API 36](https://developer.android.com/sdk/api_diff/36/changes) |

### Beta 2.1

|--------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Release date**         | February 27, 2025                                                                                                                                                                            |
| **Build**                | BP22.250124.010                                                                                                                                                                              |
| **Emulator support**     | x86 (64-bit), ARM (v8-A)                                                                                                                                                                     |
| **Security patch level** | February 2025                                                                                                                                                                                |
| **Google Play services** | 25.04.30                                                                                                                                                                                     |
| **API diff**             | - [Baklava Beta 1 → Baklava Beta 2](https://developer.android.com/sdk/api_diff/b-beta2-incr/changes) - [API 35 → Baklava Beta 2](https://developer.android.com/sdk/api_diff/b-beta2/changes) |

### Beta 2

|--------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Release date**         | February 13, 2025                                                                                                                                                                            |
| **Build**                | BP22.250124.009                                                                                                                                                                              |
| **Emulator support**     | x86 (64-bit), ARM (v8-A)                                                                                                                                                                     |
| **Security patch level** | February 2025                                                                                                                                                                                |
| **Google Play services** | 25.04.30                                                                                                                                                                                     |
| **API diff**             | - [Baklava Beta 1 → Baklava Beta 2](https://developer.android.com/sdk/api_diff/b-beta2-incr/changes) - [API 35 → Baklava Beta 2](https://developer.android.com/sdk/api_diff/b-beta2/changes) |

### Beta 1

|--------------------------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Release date**         | January 23, 2025                                                                                                                                                                          |
| **Build**                | BP22.250103.008                                                                                                                                                                           |
| **Emulator support**     | x86 (64-bit), ARM (v8-A)                                                                                                                                                                  |
| **Security patch level** | January 2025                                                                                                                                                                              |
| **Google Play services** | 25.02.31                                                                                                                                                                                  |
| **API diff**             | - [Baklava DP2 → Baklava Beta 1](https://developer.android.com/sdk/api_diff/b-beta1-incr/changes) - [API 35 → Baklava Beta 1](https://developer.android.com/sdk/api_diff/b-beta1/changes) |

**Android 16 Beta 4.1 (May 2025)**

This minor update to Android 16 Beta 4 includes the following fixes:

- Fixed an issue that impacted haptic performance ([Issue #392319999](https://issuetracker.google.com/issues/392319999))
- Fixed an issue that impacted 4k video recording at 4x telephoto ([Issue #396804873](https://issuetracker.google.com/issues/396804873))
- Fixed the weather map disappearing ([Issue #407282089](https://issuetracker.google.com/issues/407282089))
- Fixed an issue where the microphone indicator is stuck on ([Issue #394002077](https://issuetracker.google.com/issues/394002077))
- Fixed an issue where audio fails to play from the NDK ([Issue #410960668](https://issuetracker.google.com/issues/410960668))
- Fixed a constant battery drain issue ([Issue #406421245](https://issuetracker.google.com/issues/406421245))
- Fixed a black navigation bar appearing on transitions ([Issue #411509161](https://issuetracker.google.com/issues/411509161))
- Fixed a Google app crash when loading a website ([Issue #415097836](https://issuetracker.google.com/issues/415097836))

All eligible devices enrolled in the[Android Beta for Pixel program](https://g.co/androidbeta)will be offered an over-the-air (OTA) update to Beta 4.1.
| **Note:** See[top open issues](https://developer.android.com/about/versions/16/top-issues)for the latest list of issues that have been reported by developers and users.

## About Android 16 Beta 4

Beta 4 is now available, with the latest changes to try with your apps. This release is suitable for development, testing, and general use. While we're closing in on the release of Android 16, it is still in active development, so the Android system and apps running on it**might not always work as expected**.

Beta 4 also marks the second release since our[Platform Stability](https://developer.android.com/about/versions/16/overview#platform_stability)milestone, which means that Android 16 has reached final internal and external APIs and final app-facing behaviors.[Update your environment](https://developer.android.com/about/versions/16/setup-sdk)and start your final[compatibility testing](https://developer.android.com/about/versions/16/migration#compat)now so you can publish any necessary compatibility updates ahead of the final release.

As with previous versions, Android 16 includes system changes. In some cases, these changes can affect apps until they are updated to support Android 16, so you might see impacts ranging from minor issues to more significant limitations. In general, most apps will work as expected, as will most APIs and features.

## How to get Beta 4

You can install this release on any of the following Google Pixel devices:

- Pixel 6 and 6 Pro
- Pixel 7 and 7 Pro
- Pixel 7a
- Pixel Fold
- Pixel Tablet
- Pixel 8 and 8 Pro
- Pixel 8a
- Pixel 9, 9a, 9 Pro, 9 Pro XL, and 9 Pro Fold

See[Get Android 16](https://developer.android.com/about/versions/16/get)for details on how to get started.

Remember to update your SDK and the Android Emulator as well before you try out the latest features and changes. The best way to do this is using the SDK Manager in the[latest preview version of Android Studio](https://developer.android.com/studio/preview).

Depending on your development and testing needs, you can also get Android 16 in the following ways:

- Get Android 16[on a partner device](https://developer.android.com/about/versions/16/devices)
- Get Android 16[on the Android Emulator](https://developer.android.com/about/versions/16/get#on_emulator)
- Get a[Generic System Image](https://developer.android.com/about/versions/16/gsi-release-notes)(GSI)

### General advisories

Be aware of these general advisories about the release:

- This release might have various stability, battery, or performance issues.
- For users with accessibility needs, this release might not be appropriate for daily use.
- Some apps might not function as expected when running on this release. This limitation includes Google's apps as well as other apps.
- Android 16 Beta builds aren't[Compatibility Test Suite (CTS)‑approved](https://source.android.com/compatibility/cts/), but they have passed preliminary testing and provide a stable set of pre-release APIs for developers. Apps that depend on CTS-approved builds or use[Play Integrity API](https://developer.android.com/google/play/integrity)([SafetyNet APIs are deprecated](https://developer.android.com/privacy-and-security/safetynet/deprecation-timeline))might not work normally on Android 16 Beta builds.

### Get support

Two primary support channels are available to you when developing and testing with Android Beta. The channel you should use to get support depends on where you are encountering your issue.

- **Support for device-specific issues, system issues, and issues with Google apps** : Use the Issue Tracker to create new issues and to view and track issues that you and other developers have submitted. Before creating your own issue, check the known issues listed on this page and search the lists of[top open issues](https://developer.android.com/about/versions/16/top-issues)and[recently created issues](https://developer.android.com/about/versions/16/recent-issues)to see if someone else has already reported it. You can subscribe and vote for an issue by clicking**star this issue** . See[Where to report issues](https://developer.android.com/about/versions/16/feedback#templates)to find an issue template that best matches the type of issue that you are encountering.
- **Support for issues with other apps**: Contact the app developer directly.

To discuss issues or ideas with other developers and users working with Android 16 Beta, join the[android_beta community on Reddit](https://developer.android.com/about/versions/16/dev-community).

## Top resolved issues

Android 16 Beta 4 resolves the top issues that are described in the following sections and includes fixes for some issues that are not noted here.

### Developer- and user-reported issues

- Fixed issue that caused the radar map to disappear in the Pixel weather app. ([Issue# 407282089](https://issuetracker.google.com/issues/407282089))
- Fixed issues that impacted haptic performance and delayed feedback (Issues #[400455826](https://issuetracker.google.com/issues/400455826),[398829454](https://issuetracker.google.com/issues/398829454))
- Fixed issue that caused excessive power drain on some devices ([Issue # 395519809](https://issuetracker.google.com/issues/395519809))
- Fixed issue that caused a system restart when a call was answered in some situations ([Issue # 402639338](https://issuetracker.google.com/issues/402639338))
- Fixed issue that caused restart when screen magnification is enabled ([Issue # 408330740](https://issuetracker.google.com/issues/408330740))
- Fixed issue where screen saver did not start ([Issue # 398963286](https://issuetracker.google.com/issues/398963286))
- Fixed issue where phone restarted when ranging API used ([Issue # 406577030](https://issuetracker.google.com/issues/406577030))

### Other resolved issues

- Fixed various other issues that impacted system stability and performance, including a launcher crash

### Apps

- Apps that depend on any of the following libraries might experience intermittent crashes and other stability issues because these libraries rely on[internal ART structures](https://developer.android.com/about/versions/16/behavior-changes-all#art-changes):
  - HiddenApiBypass (`org.lsposed.hiddenapibypass:hiddenapibypass`)
  - FlyCore (`cn.fly:FlyCore`) before v2025.0224.1629

## Previous preview releases

The following sections describe each of the previous releases during this preview cycle.

## About Android 16 Beta 3

[Beta 3 is now available](https://android-developers.googleblog.com/2025/03/the-third-beta-of-android-16.html), with the latest features and changes to try with your apps. This release is suitable for development, testing, and general use. However, Android 16 is still in active development, so the Android system and apps running on it**might not always work as expected**.

Beta 3 also marks the[Platform Stability](https://developer.android.com/about/versions/16/overview#platform-stability)milestone, which means that Android 15 has reached final internal and external APIs and final app-facing behaviors.[Update your environment](https://developer.android.com/about/versions/16/setup-sdk)and start your final[compatibility testing](https://developer.android.com/about/versions/16/migration#compat)now so you can publish any necessary compatibility updates ahead of the final release.

As with previous versions, Android 16 includes system changes. In some cases, these changes can affect apps until they are updated to support Android 16, so you might see impacts ranging from minor issues to more significant limitations. In general, most apps will work as expected, as will most APIs and features, but please review any[known issues listed on this page](https://developer.android.com/about/versions/16/release-notes#ki-beta2)to get a better idea of what to expect.

#### Minor updates

The following minor updates were released for Beta 3 before the Beta 4 release:  
**Android 16 Beta 3.2 (April 2025)**

This minor update to Android 16 Beta 3 includes the following fixes:

- Fixed an issue that caused haptic feedback to be miscalibrated in some cases. ([Issue #392319999](https://issuetracker.google.com/issues/392319999),[Issue #400455826](https://issuetracker.google.com/issues/400455826))
- Fixed an issue that caused excessive battery drain even while a device wasn't in use. ([Issue #398329457](https://issuetracker.google.com/issues/398329457))
- Fixed an issue for Pixel 6 and 6 Pro devices that sometimes caused the screen to flicker when taking photos or videos with the camera.
- Fixed various other issues that were impacting system stability and usability.

All eligible devices enrolled in the[Android Beta for Pixel program](https://g.co/androidbeta)will be offered an over-the-air (OTA) update to Beta 3.2.
**Note:** Other known issues[listed for the Beta 3 release](https://developer.android.com/about/versions/16/release-notes#ki-beta3)still apply to Beta 3.2. In addition, see[top open issues](https://developer.android.com/about/versions/16/top-issues)for the latest list of issues that have been reported by developers and users.  
**Android 16 Beta 3.1 (March 2025)**

This minor update to Android 16 Beta 3 includes the following fixes:

- Fixed an issue that caused the system Settings app to crash repeatedly on launch if the system language was set to a language other than English. ([Issue #403303683](https://issuetracker.google.com/issues/403303683))
- Fixed an issue that caused the screen brightness to oscillate between an app-specified brightness setting and the automatic, system-specified or user-specified brightness settings. ([Issue #392522561](https://issuetracker.google.com/issues/392522561))
- Fixed a performance issue that was causing excessive battery drain from high CPU load.
- Fixed a performance issue that sometimes caused memory leaks in the system server.

All eligible devices enrolled in the[Android Beta for Pixel program](https://g.co/androidbeta)will be offered an over-the-air (OTA) update to Beta 3.1.
| **Note:** Other known issues[listed for the Beta 3 release](https://developer.android.com/about/versions/16/release-notes#ki-beta3)still apply to Beta 3.1. In addition, see[top open issues](https://developer.android.com/about/versions/16/top-issues)for the latest list of issues that have been reported by developers and users.

## What's new in Beta 3

Android 16 Beta 3 includes new features and changes to try out with your apps:

- [Local network permission](https://developer.android.com/privacy-and-security/local-network-permission)
- [Outline text for maximum text contrast](https://developer.android.com/about/versions/16/features#outline-text)

## How to get Beta 3

You can install this release on any of the following Google Pixel devices:

- Pixel 6 and 6 Pro
- Pixel 6a
- Pixel 7 and 7 Pro
- Pixel 7a
- Pixel Fold
- Pixel Tablet
- Pixel 8 and 8 Pro
- Pixel 8a
- Pixel 9, 9 Pro, 9 Pro XL, and 9 Pro Fold
- Pixel 9a

If you're already running a Developer Preview or Beta build, you will automatically receive an over-the-air (OTA) update to Beta 3. Otherwise, see[Get Android 16](https://developer.android.com/about/versions/16/get)for details on how to get started.

Remember to update your SDK and the Android Emulator as well before you try out the latest features and changes. The best way to do this is using the SDK Manager in the[latest preview version of Android Studio](https://developer.android.com/studio/preview).

Depending on your development and testing needs, you can also get Android 16 in the following ways:

- Get Android 16[on a partner device](https://developer.android.com/about/versions/16/devices).

<!-- -->

- Get Android 16[on the Android Emulator](https://developer.android.com/about/versions/16/get#on_emulator).

<!-- -->

- Get a[generic system image (GSI)](https://developer.android.com/about/versions/16/get#on_gsi).

### General advisories

Be aware of these general advisories about the release:

- This release might have various stability, battery, or performance issues.
- For users with accessibility needs, this release might not be appropriate for daily use.
- Some apps might not function as expected when running on this release. This limitation includes Google's apps as well as other apps.
- Android 16 QPR beta builds aren't[Compatibility Test Suite (CTS)](https://source.android.com/compatibility/cts/)-approved, but they have passed preliminary testing and provide a stable set of pre-release APIs for developers. Apps that depend on CTS-approved builds or use the[Play Integrity API](https://developer.android.com/google/play/integrity)([SafetyNet APIs are deprecated](https://developer.android.com/privacy-and-security/safetynet/deprecation-timeline)) might not work normally on Android 16 QPR beta builds.

### Get support

Two primary support channels are available to you when developing and testing with Android 16 QPR2. The channel you should use to get support depends on where you are encountering your issue.

- **Support for device-specific issues, system issues, and issues with Google apps**: Use the Issue Tracker to create new issues and to view and track issues that you and other developers have submitted.

  Before creating your own issue, check the known issues listed on this page and search the lists of[top open issues](https://developer.android.com/about/versions/16/top-issues)and[recently created issues](https://developer.android.com/about/versions/16/recent-issues)to see if someone else has already reported it. You can subscribe and vote for an issue by clicking**star this issue** ![](https://developer.android.com/static/images/shared/star-issue.svg).

  See[Where to report issues](https://developer.android.com/about/versions/16/feedback#templates)to find an issue template that best matches the type of issue that you are encountering.
- **Support for issues with other apps**: Contact the app developer directly.

To discuss issues or ideas with other developers working with the Android 16 QPR Beta, join the[android_beta community on Reddit](https://developer.android.com/about/versions/16/dev-community).

## Top resolved issues

Android 16 Beta 3 resolves the top issues that are described in the following sections and includes fixes for some issues that are not noted here.

### Developer- and user-reported issues

- Fixed various issues that were causing excessive battery drain in some cases. ([Issue #396603519](https://issuetracker.google.com/issues/396603519),[Issue #396757426](https://issuetracker.google.com/issues/396757426),[Issue #400066003](https://issuetracker.google.com/issues/400066003),[Issue #397088375](https://issuetracker.google.com/issues/397088375))
- Fixed issues that sometimes caused devices to reboot unexpectedly. ([Issue #400003800](https://issuetracker.google.com/issues/400003800))
- Fixed an issue that caused the At a Glance widget to display out of date information on the always-on-display. ([Issue #392132215](https://issuetracker.google.com/issues/392132215))

### Other resolved issues

- Fixed various other issues that impacted system stability, performance, and Bluetooth pairing.

## Top open issues

See[top open issues](https://developer.android.com/about/versions/16/top-issues)for the latest list of top open issues that have been reported by developers.

## Other known issues

Based on our testing, you might encounter the following issues when using Android 16 Beta 3. These issues are already known, so there's no need to file additional reports for similar issues.

### Android platform

- Simulated touch events fail while using ADB or accessibility services.
- Haptics intensity feels different since last update.

### Apps

- Apps that depend on any of the following libraries might experience intermittent crashes and other stability issues because these libraries rely on[internal ART structures](https://developer.android.com/about/versions/16/behavior-changes-all#art-changes):
  - HiddenApiBypass (`org.lsposed.hiddenapibypass:hiddenapibypass`)
  - FlyCore (`cn.fly:FlyCore`) before v2025.0224.1629
- The audio for the YouTube app sometimes continues playing in the background if, after the video is paused, the app is minimized, and then a video is played through another app.
- The screen on a device sometimes flickers when interacting with UI elements in the Google Meet app.
- The Google TV app sometimes crashes during launch and displays a "There was an error" message.
- The Google TV app sometimes displays a blank screen if the app is reopened shortly after it was closed.

### Android 16 Beta 2

[Beta 2 is now available](https://android-developers.googleblog.com/2025/02/second-beta-android16.html), with the latest features and changes to try with your apps. This release is suitable for development, testing, and general use. However, Android 16 is still in active development, so the Android system and apps running on it**might not always work as expected**.

As with previous versions, Android 16 includes system changes. In some cases, these changes can affect apps until they are updated to support Android 16, so you might see impacts ranging from minor issues to more significant limitations. In general, most apps will work as expected, as will most APIs and features, but please review any[known issues listed on this page](https://developer.android.com/about/versions/16/release-notes#ki-beta2)to get a better idea of what to expect.

#### Minor updates

The following minor updates were released for Beta 2 before the Beta 3 release:  
**Android 16 Beta 2.1 (February 2025)**

This minor update to Android 16 Beta 2 includes the following fixes:

- Fixed an issue that sometimes prevented devices from entering Doze mode. ([Issue #396603519](https://issuetracker.google.com/issues/396603519))
- Fixed issues that caused some animations to appear choppy while configuring live wallpapers. ([Issue #397659072](https://issuetracker.google.com/issues/397659072))
- Fixed an issue that sometimes caused devices to reboot unexpectedly. ([Issue #396541565](https://issuetracker.google.com/issues/396541565))
- Fixed various other issues that were impacting system stability, connectivity, and performance.

All eligible devices enrolled in the[Android Beta for Pixel program](https://g.co/androidbeta)will be offered an over-the-air (OTA) update to Beta 2.1.
| **Note:** See[top open issues](https://developer.android.com/about/versions/16/top-issues)for the latest list of issues that have been reported by developers and users.

#### What's new in Beta 2

Android 16 Beta 2 includes new features and changes to try out with your apps:

- [Abandoned empty jobs stop reason](https://developer.android.com/about/versions/16/behavior-changes-all#abandoned-job-stop-reason)
- [16 KB page size compatibility mode](https://developer.android.com/about/versions/16/behavior-changes-all#16-kb-compatibility-mode)
- [Improved security against Intent redirection attacks](https://developer.android.com/about/versions/16/behavior-changes-all#intent-redirect-attacks)
- [Edge to edge opt-out going away](https://developer.android.com/about/versions/16/behavior-changes-16#edge-to-edge)
- [Elegant font APIs deprecated and disabled](https://developer.android.com/about/versions/16/behavior-changes-16#elegant-text-height)
- [Hybrid auto-exposure](https://developer.android.com/about/versions/16/features#hybrid-auto-exposure)
- [Precise color temperature and tint adjustments](https://developer.android.com/about/versions/16/features#color-temperature-tint)
- [Motion photo capture intent actions](https://developer.android.com/about/versions/16/features#motion-photos)
- [UltraHDR image enhancements](https://developer.android.com/about/versions/16/features#ultra-hdr)
- [Custom graphical effects with AGSL](https://developer.android.com/about/versions/16/features#agsl)
- [Measurement system customization](https://developer.android.com/about/versions/16/features#measurement-systems)
- [Content handling for live wallpapers](https://developer.android.com/about/versions/16/features#live-wallpapers)
- [Headroom APIs in ADPF](https://developer.android.com/about/versions/16/features#headroom-apis)
- [Key sharing API](https://developer.android.com/about/versions/16/features#key-sharing)
- [Standardized picture and audio quality framework for TVs](https://developer.android.com/about/versions/16/features#media-quality-apis)
- [Improved accessibility APIs](https://developer.android.com/about/versions/16/features#a11y-apis)

#### Top resolved issues

Android 16 Beta 2 resolves the top issues that are described in the following sections and includes fixes for some issues that are not noted here.

##### Developer- and user-reported issues

- Fixed an issue that sometimes caused the system UI to crash when interacting with certain elements in WebViews. ([Issue #392011635](https://issuetracker.google.com/issues/392011635))
- Fixed issues that sometimes caused devices to freeze and restart during calls. ([Issue #392364716](https://issuetracker.google.com/issues/392364716))
- Fixed issues that caused the Google Home app to crash intermittently when running on Android 16 Beta builds. ([Issue #391922779](https://issuetracker.google.com/issues/391922779))
- Fixed issues where the language picker menu (accessed by long pressing the spacebar) was changing the window, which caused the IME to hide in apps that had set their`softInputMode`to`STATE_ALWAYS_HIDDEN`. ([Issue #388201594](https://issuetracker.google.com/issues/388201594))

##### Other resolved issues

- Fixed an issue with Java LazyValue ClassLoader that sometimes caused apps to crash with a`ClassNotFoundException`.

#### Other known issues

Based on our testing, you might encounter the following issues when using Android 16 Beta 2. These issues are already known, so there's no need to file additional reports for similar issues.

##### Android platform

- Simulated touch events fail while using ADB or accessibility services.

##### Apps

- Apps that depend on any of the following libraries might experience intermittent crashes and other stability issues because these libraries rely on[internal ART structures](https://developer.android.com/about/versions/16/behavior-changes-all#art-changes):
  - HiddenApiBypass (`org.lsposed.hiddenapibypass:hiddenapibypass`)
  - FlyCore (`cn.fly:FlyCore`) before v2025.0224.1629
- The audio for the YouTube app sometimes continues playing in the background if, after the video is paused, the app is minimized, and then a video is played through another app.
- The screen on a device sometimes flickers when interacting with UI elements in the Google Meet app.
- The Google TV app sometimes crashes during launch and displays a "There was an error" message.
- The Google TV app sometimes displays a blank screen if the app is reopened shortly after it was closed.

### Android 16 Beta 1

[Beta 1 is now available](https://android-developers.googleblog.com/2025/01/first-beta-android16.html), with the latest features and changes to try with your apps. Beta 1 is also the first Android 16 release for early adopters and Android enthusiasts who want to try out what's coming in Android 16. This release is suitable for development, testing, and general use. However, Android 16 is still in active development, so the Android system and apps running on it**might not always work as expected**.

As with previous versions, Android 16 includes system changes. In some cases, these changes can affect apps until they are updated to support Android 16, so you might see impacts ranging from minor issues to more significant limitations. In general, most apps will work as expected, as will most APIs and features, but please review any[known issues listed on this page](https://developer.android.com/about/versions/16/release-notes#ki-beta2)to get a better idea of what to expect.

#### What's new in Beta 1

Android 16 Beta 1 includes new features and changes to try out with your apps:

- [Ordered broadcast priority scope no longer global](https://developer.android.com/about/versions/16/behavior-changes-all#ordered-broadcast-priority)
- [ART internal changes](https://developer.android.com/about/versions/16/behavior-changes-all#art-changes)
- [Support for 3-button navigation](https://developer.android.com/about/versions/16/behavior-changes-all#three-button-predictive-back)
- [Virtual device owner overrides](https://developer.android.com/about/versions/16/behavior-changes-all#virtual-device-owner-overrides)
- [Migration or opt-out required for predictive back](https://developer.android.com/about/versions/16/behavior-changes-16#predictive-back)
- [Fixed rate work scheduling optimization](https://developer.android.com/about/versions/16/behavior-changes-16#schedule-at-fixed-rate)
- [Adaptive layouts](https://developer.android.com/about/versions/16/behavior-changes-16#adaptive-layouts)
- [Health and fitness permissions](https://developer.android.com/about/versions/16/behavior-changes-16#health-fitness-permissions)
- [Progress-centric notifications](https://developer.android.com/about/versions/16/features/live-updates)
- [Supplemental descriptions](https://developer.android.com/about/versions/16/features#supplemental-descriptions)
- [Required form fields](https://developer.android.com/about/versions/16/features#required-form-fields)
- [Camera night mode scene detection](https://developer.android.com/about/versions/16/features#night-mode-scene-detection)
- [Generic ranging APIs](https://developer.android.com/about/versions/16/features#generic-ranging)
- [Advanced Professional Video](https://developer.android.com/about/versions/16/features#apv)
- [Vertical text](https://developer.android.com/about/versions/16/features#vertical-text)
- [Phone as microphone input for voice calls with LEA hearing aids](https://developer.android.com/about/versions/16/features#lea-phone-input)
- [Ambient volume controls for LEA hearing aids](https://developer.android.com/about/versions/16/features#lea-ambient-volume)

#### Top resolved issues

Android 16 Beta 1 resolves the top issues that are described in the following sections and includes fixes for some issues that are not noted here.

- Fixed an issue that caused NFC payments to fail in some cases due to a null pointer exception.
- Fixed an issue that caused excessive battery drain when some apps were running in the background.
- Fixed an issue where tapping an ongoing media notification sometimes failed to launch the corresponding app.
- Fixed an issue where, on some devices, the camera screen sometimes flashed if the zoom level was adjusted while recording video.
- Fixed various other issues that were impacting system stability.

#### Other known issues

Based on our testing, you might encounter the following issues when using Android 16 Beta 1. These issues are already known, so there's no need to file additional reports for similar issues.

##### Android platform

- An issue with Java LazyValue ClassLoader sometimes causes apps to crash with a`ClassNotFoundException`.
- Simulated touch events fail while using ADB or accessibility services.

##### Apps

- Apps that depend on any of the following libraries might experience intermittent crashes and other stability issues because these libraries rely on[internal ART structures](https://developer.android.com/about/versions/16/behavior-changes-all#art-changes):
  - HiddenApiBypass (`org.lsposed.hiddenapibypass:hiddenapibypass`)
  - FlyCore (`cn.fly:FlyCore`) before v2025.0224.1629
- The audio for the YouTube app sometimes continues playing in the background if, after the video is paused, the app is minimized, and then a video is played through another app.
- The Google TV app sometimes crashes during launch and displays a "There was an error" message.
- The Google TV app sometimes displays a blank screen if the app is reopened shortly after it was closed.

### Android 16 Developer Preview 2

### Developer Preview 2

|--------------------------|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Release date**         | December 18, 2024                                                                                                                                                               |
| **Build**                | BP21.241121.009                                                                                                                                                                 |
| **Emulator support**     | x86 (64-bit), ARM (v8-A)                                                                                                                                                        |
| **Security patch level** | December 2024                                                                                                                                                                   |
| **Google Play services** | 24.46.30                                                                                                                                                                        |
| **API diff**             | - [Baklava DP1 → Baklava DP2](https://developer.android.com/sdk/api_diff/b-dp2-incr/changes) - [API 35 → Baklava DP2](https://developer.android.com/sdk/api_diff/b-dp2/changes) |

[Developer Preview 2 is now available](https://android-developers.googleblog.com/2024/12/second-developer-preview-android16.html), with the latest features and changes to try with your apps. This build includes changes designed to enhance the app experience, improve battery life, and boost performance while minimizing incompatibilities, and your feedback is critical in helping us understand the full impact of this work.

This release is for developers only, to help with early development, testing, and feedback. Android 15 Developer Preview 2 is an early baseline build that's still in active development, so the Android system and apps running on it**might not always work as expected**.

#### What's new in Developer Preview 2

Android 16 Developer Preview 2 includes new features and changes to try out with your apps:

- [JobScheduler quota optimizations](https://developer.android.com/about/versions/16/behavior-changes-all#job-quota-opt)
- [Deprecating disruptive accessibility announcements](https://developer.android.com/about/versions/16/behavior-changes-all#disruptive-a11y)
- [Predictive back updates](https://developer.android.com/about/versions/16/features#predictive-back-updates)
- [Richer haptics](https://developer.android.com/about/versions/16/features#rich-haptics)
- [System-triggered profiling](https://developer.android.com/about/versions/16/features#system-triggered-profiling)
- [Start component in ApplicationStartInfo](https://developer.android.com/about/versions/16/features#start-component)
- [Better job introspection](https://developer.android.com/about/versions/16/features#feature-pending-job-reason-history)
- [Adaptive refresh rate](https://developer.android.com/about/versions/16/features#arr)
- [Ranging with enhanced security](https://developer.android.com/about/versions/16/features#secure-ranging)
- [Photo picker improvements](https://developer.android.com/about/versions/16/features#photo-picker-improvements)
- [Health Connect updates](https://developer.android.com/about/versions/16/features#health-connect)

#### Top resolved issues

Android 16 Developer Preview 2 resolves the top issues that are described in the following sections and includes fixes for some issues that are not noted here.

##### Developer-reported issues

- Fixed an issue that sometimes caused the screen brightness on a device to be set to 0% when the device was woken up. ([Issue #379979158](https://issuetracker.google.com/issues/379979158))
- Fixed an issue that caused the Terminal app to display a "No local assets" error when launched. ([Issue #380010668](https://issuetracker.google.com/issues/380010668))

#### Other known issues

Based on our testing, you might encounter the following issues when using Android 16 Developer Preview 2. These issues are already known, so there's no need to file additional reports for similar issues.

##### Android platform

- Simulated touch events fail while using ADB or accessibility services.
- Tapping an ongoing media notification sometimes fails to launch the corresponding app.
- On some devices, the camera screen sometimes flashes if the zoom level is adjusted while recording video.

### Android 16 Developer Preview 1

### Developer Preview 1

|--------------------------|------------------------------------------------------------------------------------|
| **Release date**         | November 19, 2024                                                                  |
| **Build**                | BP21.241018.009                                                                    |
| **Emulator support**     | x86 (64-bit), ARM (v8-A)                                                           |
| **Security patch level** | November 2024                                                                      |
| **Google Play services** | 24.40.35                                                                           |
| **API diff**             | - [API 35 → Baklava DP1](https://developer.android.com/sdk/api_diff/b-dp1/changes) |

Welcome to the Android 16 Developer Preview! This first release is for developers only, to help with early development, testing, and feedback. Android 16 Developer Preview 1 is an early baseline build that's still in active development, so the Android system and apps running on it**might not always work as expected**.

#### What's new in Developer Preview 1

Android 16 Developer Preview 1 is the start of Android having more frequent API releases as part of our effort to drive faster innovation in apps and devices.

- [Two Android API releases in 2025](https://developer.android.com/about/versions/16/features#two-android)
- [Photo picker improvements](https://developer.android.com/about/versions/16/features#photo-picker-improvements)
- [Health Connect updates](https://developer.android.com/about/versions/16/features#health-connect)
- [Privacy Sandbox on Android](https://developer.android.com/about/versions/16/features#privacy-sandbox)

#### Known issues

Based on our testing, you might encounter the following issues when using Android 16 Developer Preview 1. These issues are already known, so there's no need to file additional reports for similar issues.

##### Android platform

- Tapping an ongoing media notification sometimes fails to launch the corresponding app.
- On some devices, the camera screen sometimes flashes if the zoom level is adjusted while recording video.